JUCE: OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > Class Template Reference
juce_core » containers

An array designed for holding objects. More...

`#include <juce_OwnedArray.h>`

## Public Types
using | ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType
| Returns the type of scoped lock to use for locking this array.

## Public Member Functions
| OwnedArray ()=default
| Creates an empty array.
| ~OwnedArray ()
| Deletes the array and also deletes any objects inside it.
| OwnedArray (OwnedArray &&other) noexcept
| Move constructor.
| OwnedArray (const std::initializer_list< ObjectClass * > &items)
| Creates an array from a list of objects.
OwnedArray & | operator= (OwnedArray &&other) noexcept
| Move assignment operator.
template<class OtherObjectClass , class OtherCriticalSection >
| OwnedArray (OwnedArray< OtherObjectClass, OtherCriticalSection > &&other) noexcept
| Converting move constructor.
template<class OtherObjectClass , class OtherCriticalSection >
OwnedArray & | operator= (OwnedArray< OtherObjectClass, OtherCriticalSection > &&other) noexcept
| Converting move assignment operator.
void | clear (bool deleteObjects=true)
| Clears the array, optionally deleting the objects inside it first.
void | clearQuick (bool deleteObjects)
| Clears the array, optionally deleting the objects inside it first.
int | size () const noexcept
| Returns the number of items currently in the array.
bool | isEmpty () const noexcept
| Returns true if the array is empty, false otherwise.
ObjectClass * | operator[] (int index) const noexcept
| Returns a pointer to the object at this index in the array.
ObjectClass * | getUnchecked (int index) const noexcept
| Returns a pointer to the object at this index in the array, without checking whether the index is in-range.
ObjectClass * | getFirst () const noexcept
| Returns a pointer to the first object in the array.
ObjectClass * | getLast () const noexcept
| Returns a pointer to the last object in the array.
ObjectClass ** | getRawDataPointer () noexcept
| Returns a pointer to the actual array data.
ObjectClass ** | begin () noexcept
| Returns a pointer to the first element in the array.
ObjectClass *const * | begin () const noexcept
| Returns a pointer to the first element in the array.
ObjectClass ** | end () noexcept
| Returns a pointer to the element which follows the last element in the array.
ObjectClass *const * | end () const noexcept
| Returns a pointer to the element which follows the last element in the array.
ObjectClass ** | data () noexcept
| Returns a pointer to the first element in the array.
ObjectClass *const * | data () const noexcept
| Returns a pointer to the first element in the array.
int | indexOf (const ObjectClass *objectToLookFor) const noexcept
| Finds the index of an object which might be in the array.
bool | contains (const ObjectClass *objectToLookFor) const noexcept
| Returns true if the array contains a specified object.
ObjectClass * | add (ObjectClass *newObject)
| Appends a new object to the end of the array.
ObjectClass * | add (std::unique_ptr< ObjectClass > newObject)
| Appends a new object to the end of the array.
ObjectClass * | insert (int indexToInsertAt, ObjectClass *newObject)
| Inserts a new object into the array at the given index.
ObjectClass * | insert (int indexToInsertAt, std::unique_ptr< ObjectClass > newObject)
| Inserts a new object into the array at the given index.
void | insertArray (int indexToInsertAt, ObjectClass *const *newObjects, int numberOfElements)
| Inserts an array of values into this array at a given position.
ObjectClass * | set (int indexToChange, ObjectClass *newObject, bool deleteOldElement=true)
| Replaces an object in the array with a different one.
ObjectClass * | set (int indexToChange, std::unique_ptr< ObjectClass > newObject, bool deleteOldElement=true)
| Replaces an object in the array with a different one.
template<class OtherArrayType >
void | addArray (const OtherArrayType &arrayToAddFrom, int startIndex=0, int numElementsToAdd=-1)
| Adds elements from another array to the end of this array.
template<typename OtherArrayType >
void | addArray (const std::initializer_list< OtherArrayType > &items)
| Adds elements from another array to the end of this array.
template<class OtherArrayType >
void | addCopiesOf (const OtherArrayType &arrayToAddFrom, int startIndex=0, int numElementsToAdd=-1)
| Adds copies of the elements in another array to the end of this array.
template<class ElementComparator >
int | addSorted (ElementComparator &comparator, ObjectClass *newObject) noexcept
| Inserts a new object into the array assuming that the array is sorted.
template<typename ElementComparator >
int | indexOfSorted (ElementComparator &comparator, const ObjectClass *objectToLookFor) const noexcept
| Finds the index of an object in the array, assuming that the array is sorted.
void | remove (int indexToRemove, bool deleteObject=true)
| Removes an object from the array.
ObjectClass * | removeAndReturn (int indexToRemove)
| Removes and returns an object from the array without deleting it.
void | removeObject (const ObjectClass *objectToRemove, bool deleteObject=true)
| Removes a specified object from the array.
void | removeRange (int startIndex, int numberToRemove, bool deleteObjects=true)
| Removes a range of objects from the array.
void | removeLast (int howManyToRemove=1, bool deleteObjects=true)
| Removes the last n objects from the array.
void | swap (int index1, int index2) noexcept
| Swaps a pair of objects in the array.
void | move (int currentIndex, int newIndex) noexcept
| Moves one of the objects to a different position.
template<class OtherArrayType >
void | swapWith (OtherArrayType &otherArray) noexcept
| This swaps the contents of this array with those of another array.
void | minimiseStorageOverheads () noexcept
| Reduces the amount of storage being used by the array.
void | ensureStorageAllocated (int minNumElements) noexcept
| Increases the array's internal storage to hold a minimum number of elements.
template<class ElementComparator >
void | sort (ElementComparator &comparator, bool retainOrderOfEquivalentItems=false) noexcept
| Sorts the elements in the array.
const TypeOfCriticalSectionToUse & | getLock () const noexcept
| Returns the CriticalSection that locks this array.

## Detailed Description

template<class ObjectClass, class TypeOfCriticalSectionToUse = DummyCriticalSection>
class OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >

An array designed for holding objects.

This holds a list of pointers to objects, and will automatically delete the objects when they are removed from the array, or when the array is itself deleted.

Declare it in the form: OwnedArray<MyObjectClass>

..and then add new objects, e.g. myOwnedArray.add (new MyObjectClass());

After adding objects, they are 'owned' by the array and will be deleted when removed or replaced.

To make all the array's methods thread-safe, pass in "CriticalSection" as the templated TypeOfCriticalSectionToUse parameter, instead of the default DummyCriticalSection.

See also
  Array, ReferenceCountedArray, StringArray, CriticalSection

## Member Typedef Documentation

## ◆ ScopedLockType

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

using OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::ScopedLockType = typename TypeOfCriticalSectionToUse::ScopedLockType

Returns the type of scoped lock to use for locking this array.

## Constructor & Destructor Documentation

## ◆ OwnedArray() [1/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( |  | ) |
| default

Creates an empty array.

## ◆ ~OwnedArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::~OwnedArray | ( |  | ) |

Deletes the array and also deletes any objects inside it.

To get rid of the array without deleting its objects, use its clear (false) method before deleting it.

## ◆ OwnedArray() [2/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( | OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| noexcept

Move constructor.

## ◆ OwnedArray() [3/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( | const std::initializer_list< ObjectClass * > & | items | ) |

Creates an array from a list of objects.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray().

## ◆ OwnedArray() [4/4]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass , class OtherCriticalSection >

OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray | ( | OwnedArray< OtherObjectClass, OtherCriticalSection > && | other | ) |
| noexcept

Converting move constructor.

## Member Function Documentation

## ◆ operator=() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

OwnedArray & OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | OwnedArray< ObjectClass, TypeOfCriticalSectionToUse > && | other | ) |
| noexcept

Move assignment operator.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ operator=() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherObjectClass , class OtherCriticalSection >

OwnedArray & OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator= | ( | OwnedArray< OtherObjectClass, OtherCriticalSection > && | other | ) |
| noexcept

Converting move assignment operator.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ clear()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear | ( | bool | deleteObjects = `true` | ) |

Clears the array, optionally deleting the objects inside it first.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast().

## ◆ clearQuick()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick | ( | bool | deleteObjects | ) |

Clears the array, optionally deleting the objects inside it first.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear().

## ◆ size()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::size | ( |  | ) | const
| noexcept

Returns the number of items currently in the array.

See also
  operator[]

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort().

## ◆ isEmpty()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::isEmpty | ( |  | ) | const
| noexcept

Returns true if the array is empty, false otherwise.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::size().

## ◆ operator[]()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[] | ( | int | index | ) | const
| noexcept

Returns a pointer to the object at this index in the array.

If the index is out-of-range, this will return a null pointer, (and it could be null anyway, because it's ok for the array to hold null pointers as well as objects).

See also
  getUnchecked

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ getUnchecked()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked | ( | int | index | ) | const
| noexcept

Returns a pointer to the object at this index in the array, without checking whether the index is in-range.

This is a faster and less safe version of operator[] which doesn't check the index passed in, so it can be used when you're sure the index is always going to be legal.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ getFirst()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst | ( |  | ) | const
| noexcept

Returns a pointer to the first object in the array.

This will return a null pointer if the array's empty.

See also
  getLast

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ getLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast | ( |  | ) | const
| noexcept

Returns a pointer to the last object in the array.

This will return a null pointer if the array's empty.

See also
  getFirst

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ getRawDataPointer()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getRawDataPointer | ( |  | ) |
| noexcept

Returns a pointer to the actual array data.

This pointer will only be valid until the next time a non-const method is called on the array.

## ◆ begin() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) |
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::data(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::data().

## ◆ begin() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin | ( |  | ) | const
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## ◆ end() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) |
| noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## ◆ end() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::end | ( |  | ) | const
| noexcept

Returns a pointer to the element which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

## ◆ data() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass ** OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) |
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin().

## ◆ data() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass *const * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::data | ( |  | ) | const
| noexcept

Returns a pointer to the first element in the array.

This method is provided for compatibility with the standard C++ containers.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::begin().

## ◆ indexOf()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

int OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf | ( | const ObjectClass * | objectToLookFor | ) | const
| noexcept

Finds the index of an object which might be in the array.

Parameters

  objectToLookFor | the object to look for

Returns
  the index at which the object was found, or -1 if it's not found

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ contains()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

bool OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains | ( | const ObjectClass * | objectToLookFor | ) | const
| noexcept

Returns true if the array contains a specified object.

Parameters

  objectToLookFor | the object to look for

Returns
  true if the object is in the array

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ add() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | ObjectClass * | newObject | ) |

Appends a new object to the end of the array.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

Also be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  set, insert, addSorted

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add().

## ◆ add() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add | ( | std::unique_ptr< ObjectClass > | newObject | ) |

Appends a new object to the end of the array.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

Also be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  set, insert, addSorted

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add().

## ◆ insert() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | ObjectClass * | newObject
| ) |  |

Inserts a new object into the array at the given index.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  add, addSorted, set

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert().

## ◆ insert() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert | ( | int | indexToInsertAt,
|  | std::unique_ptr< ObjectClass > | newObject
| ) |  |

Inserts a new object into the array at the given index.

Note that this object will be deleted by the OwnedArray when it is removed, so be careful not to delete it somewhere else.

If the index is less than 0 or greater than the size of the array, the element will be added to the end of the array. Otherwise, it will be inserted into the array, moving all the later elements along to make room.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToInsertAt | the index at which the new element should be inserted
  newObject | the new object to add to the array

Returns
  the new object that was added

See also
  add, addSorted, set

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert().

## ◆ insertArray()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insertArray | ( | int | indexToInsertAt,
|  | ObjectClass *const * | newObjects,
|  | int | numberOfElements
| ) |  |

Inserts an array of values into this array at a given position.

If the index is less than 0 or greater than the size of the array, the new elements will be added to the end of the array. Otherwise, they will be inserted into the array, moving all the later elements along to make room.

Parameters

  indexToInsertAt | the index at which the first new element should be inserted
  newObjects | the new values to add to the array
  numberOfElements | how many items are in the array

See also
  insert, add, addSorted, set

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ set() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | ObjectClass * | newObject,
|  | bool | deleteOldElement = `true`
| ) |  |

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.
  deleteOldElement | whether to delete the object that's being replaced with the new one

See also
  add, insert, remove

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock(), and jassertfalse.

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set().

## ◆ set() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set | ( | int | indexToChange,
|  | std::unique_ptr< ObjectClass > | newObject,
|  | bool | deleteOldElement = `true`
| ) |  |

Replaces an object in the array with a different one.

If the index is less than zero, this method does nothing. If the index is beyond the end of the array, the new object is added to the end of the array.

Be careful not to add the same object to the array more than once, as this will obviously cause deletion of dangling pointers.

Parameters

  indexToChange | the index whose value you want to change
  newObject | the new value to set for this index.
  deleteOldElement | whether to delete the object that's being replaced with the new one

See also
  add, insert, remove

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set().

## ◆ addArray() [1/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray | ( | const OtherArrayType & | arrayToAddFrom,
|  | int | startIndex = `0`,
|  | int | numElementsToAdd = `-1`
| ) |  |

Adds elements from another array to the end of this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::OwnedArray().

## ◆ addArray() [2/2]

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<typename OtherArrayType >

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray | ( | const std::initializer_list< OtherArrayType > & | items | ) |

Adds elements from another array to the end of this array.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ addCopiesOf()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addCopiesOf | ( | const OtherArrayType & | arrayToAddFrom,
|  | int | startIndex = `0`,
|  | int | numElementsToAdd = `-1`
| ) |  |

Adds copies of the elements in another array to the end of this array.

The other array must be either an OwnedArray of a compatible type of object, or an Array containing pointers to the same kind of object. The objects involved must provide a copy constructor, and this will be used to create new copies of each element, and add them to this array.

Parameters

  arrayToAddFrom | the array from which to copy the elements
  startIndex | the first element of the other array to start copying from
  numElementsToAdd | how many elements to add from the other array. If this value is negative or greater than the number of available elements, all available elements will be copied.

See also
  add

References createCopyIfNotNull(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock(), jassert, and jassertfalse.

## ◆ remove()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove | ( | int | indexToRemove,
|  | bool | deleteObject = `true`
| ) |  |

Removes an object from the array.

This will remove the object at a given index (optionally also deleting it) and move back all the subsequent objects to close the gap. If the index passed in is out-of-range, nothing will happen.

Parameters

  indexToRemove | the index of the element to remove
  deleteObject | whether to delete the object that is removed

See also
  removeObject, removeRange

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock(), isPositiveAndBelow(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject().

## ◆ removeAndReturn()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

ObjectClass * OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn | ( | int | indexToRemove | ) |

Removes and returns an object from the array without deleting it.

This will remove the object at a given index and return it, moving back all the subsequent objects to close the gap. If the index passed in is out-of-range, nothing will happen.

Parameters

  indexToRemove | the index of the element to remove

See also
  remove, removeObject, removeRange

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock(), isPositiveAndBelow(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads().

## ◆ removeObject()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject | ( | const ObjectClass * | objectToRemove,
|  | bool | deleteObject = `true`
| ) |  |

Removes a specified object from the array.

If the item isn't found, no action is taken.

Parameters

  objectToRemove | the object to try to remove
  deleteObject | whether to delete the object (if it's found)

See also
  remove, removeRange

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove().

## ◆ removeRange()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange | ( | int | startIndex,
|  | int | numberToRemove,
|  | bool | deleteObjects = `true`
| ) |  |

Removes a range of objects from the array.

This will remove a set of objects, starting from the given index, and move any subsequent elements down to close the gap.

If the range extends beyond the bounds of the array, it will be safely clipped to the size of the array.

Parameters

  startIndex | the index of the first object to remove
  numberToRemove | how many objects should be removed
  deleteObjects | whether to delete the objects that get removed

See also
  remove, removeObject

References Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::addArray(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock(), jlimit(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast().

## ◆ removeLast()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast | ( | int | howManyToRemove = `1`,
|  | bool | deleteObjects = `true`
| ) |  |

Removes the last n objects from the array.

Parameters

  howManyToRemove | how many objects to remove from the end of the array
  deleteObjects | whether to also delete the objects that are removed

See also
  remove, removeObject, removeRange

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange().

## ◆ swap()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap | ( | int | index1,
|  | int | index2
| ) |  |
| noexcept

Swaps a pair of objects in the array.

If either of the indexes passed in is out-of-range, nothing will happen, otherwise the two objects at these positions will be exchanged.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ move()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::move | ( | int | currentIndex,
|  | int | newIndex
| ) |  |
| noexcept

Moves one of the objects to a different position.

This will move the object to a specified index, shuffling along any intervening elements as required.

So for example, if you have the array { 0, 1, 2, 3, 4, 5 } then calling move (2, 4) would result in { 0, 1, 3, 4, 2, 5 }.

Parameters

  currentIndex | the index of the object to be moved. If this isn't a valid index, then nothing will be done
  newIndex | the index at which you'd like this object to end up. If this is less than zero, it will be moved to the end of the array

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ swapWith()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>
template<class OtherArrayType >

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith | ( | OtherArrayType & | otherArray | ) |
| noexcept

This swaps the contents of this array with those of another array.

If you need to exchange two arrays, this is vastly quicker than using copy-by-value because it just swaps their internal pointers.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ minimiseStorageOverheads()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads | ( |  | ) |
| noexcept

Reduces the amount of storage being used by the array.

Arrays typically allocate slightly more storage than they need, and after removing elements, they may have quite a lot of unused space allocated. This method will reduce the amount of allocated storage to a minimum.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange().

## ◆ ensureStorageAllocated()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

void OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated | ( | int | minNumElements | ) |
| noexcept

Increases the array's internal storage to hold a minimum number of elements.

Calling this before adding a large known number of elements means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

References OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock().

## ◆ getLock()

template<class ObjectClass , class TypeOfCriticalSectionToUse = DummyCriticalSection>

const TypeOfCriticalSectionToUse & OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLock | ( |  | ) | const
| noexcept

Returns the CriticalSection that locks this array.

To lock, you can call getLock().enter() and getLock().exit(), or preferably use an object of ScopedLockType as an RAII lock for it.

Referenced by OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::add(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addArray(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addCopiesOf(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::addSorted(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clear(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::clearQuick(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::contains(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::ensureStorageAllocated(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getFirst(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getLast(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::getUnchecked(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOf(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::indexOfSorted(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::insertArray(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::minimiseStorageOverheads(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::move(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator=(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator=(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::operator[](), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::remove(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeAndReturn(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeLast(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeRange(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::set(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::sort(), OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swap(), and OwnedArray< ObjectClass, TypeOfCriticalSectionToUse >::swapWith().

The documentation for this class was generated from the following file:

- juce_OwnedArray.h